PHP在代碼調試中的異常處理辦法

異常(Exception)用於在指定的錯誤發生時改變腳本的正常流程。


什麼是異常?

PHP 5 提供瞭一種新的面向對象的錯誤處理方法。

異常處理用於在指定的錯誤(異常)情況發生時改變腳本的正常流程。這種情況稱為異常。

當異常被觸發時,通常會發生:

當前代碼狀態被保存
代碼執行被切換到預定義的異常處理器函數
根據情況,處理器也許會從保存的代碼狀態重新開始執行代碼,終止腳本執行,或從代碼中另外的位置繼續執行腳本
我們將展示不同的錯誤處理方法:

異常的基本使用
創建自定義的異常處理器
多個異常
重新拋出異常
設置頂層異常處理器
異常的基本使用
當異常被拋出時,其後的代碼不會繼續執行,PHP 會嘗試查找匹配的 "catch" 代碼塊。

如果異常沒有被捕獲,而且又沒用使用 set_exception_handler() 作相應的處理的話,那麼將發生一個嚴重的錯誤(致命錯誤),並且輸出 "Uncaught Exception" (未捕獲異常)的錯誤消息。

讓我們嘗試拋出一個異常,同時不去捕獲它:

<?php
//create function with an exceptionfunction
checkNum($number) {
if($number>1)  { 
throw new Exception("Value must be 1 or below"); 
} return true;
}
//trigger
exceptioncheckNum(2);
?>
上面的代碼會獲得類似這樣的一個錯誤:

Fatal error: Uncaught exception Exception with message Value must be 1 or below in C:webfolder est.php:6 Stack trace: #0 C:webfolder est.php(12): checkNum(28) #1 {main} thrown in C:webfolder est.php on line 6
Try, throw 和 catch
要避免上面例子出現的錯誤,我們需要創建適當的代碼來處理異常。

處理處理程序應當包括:

Try – 使用異常的函數應該位於 "try" 代碼塊內。如果沒有觸發異常,則代碼將照常繼續執行。但是如果異常被觸發,會拋出一個異常。
Throw – 這裡規定如何觸發異常。每一個 "throw" 必須對應至少一個 "catch"
Catch – "catch" 代碼塊會捕獲異常,並創建一個包含異常信息的對象
讓我們觸發一個異常:

<?php//創建可拋出一個異常的函數function checkNum($number) { if($number>1)  {  throw new Exception("Value must be 1 or below");  } return true; }//在 "try" 代碼塊中觸發異常try { checkNum(2); //If the exception is thrown, this text will not be shown echo If you see this, the number is 1 or below; }//捕獲異常catch(Exception $e) { echo Message: .$e->getMessage(); }?>
上面代碼將獲得類似這樣一個錯誤:

Message: Value must be 1 or below
例子解釋:
上面的代碼拋出瞭一個異常,並捕獲瞭它:

創建 checkNum() 函數。它檢測數字是否大於 1。如果是,則拋出一個異常。
在 "try" 代碼塊中調用 checkNum() 函數。
checkNum() 函數中的異常被拋出
"catch" 代碼塊接收到該異常,並創建一個包含異常信息的對象 ($e)。
通過從這個 exception 對象調用 $e->getMessage(),輸出來自該異常的錯誤消息
不過,為瞭遵循“每個 throw 必須對應一個 catch”的原則,可以設置一個頂層的異常處理器來處理漏掉的錯誤。
創建一個自定義的 Exception 類
創建自定義的異常處理程序非常簡單。我們簡單地創建瞭一個專門的類,當 PHP 中發生異常時,可調用其函數。該類必須是 exception 類的一個擴展。

這個自定義的 exception 類繼承瞭 PHP 的 exception 類的所有屬性,您可向其添加自定義的函數。

我們開始創建 exception 類:

<?php
class customException extends Exception {
public function errorMessage()  { 
//error message 
$errorMsg = Error on line .$this->getLine(). in .$this->getFile()  .: <b>.$this->getMessage().</b> is not a valid E-Mail address;  return $errorMsg; 
  }
}
$email = "someone@example…com";try {
//check if 
if(filter_var($email, FILTER_VALIDATE_EMAIL) === FALSE)  { 
//throw exception if email is not valid  throw
new customException($email); 
}
}catch (customException $e)
{
//display custom message
echo $e->errorMessage();
}?>
這個新的類是舊的 exception 類的副本,外加 errorMessage() 函數。正因為它是舊類的副本,因此它從舊類繼承瞭屬性和方法,我們可以使用 exception 類的方法,比如 getLine() 、 getFile() 以及 getMessage()。

例子解釋:
上面的代碼拋出瞭一個異常,並通過一個自定義的 exception 類來捕獲它:

customException() 類是作為舊的 exception 類的一個擴展來創建的。這樣它就繼承瞭舊類的所有屬性和方法。
創建 errorMessage() 函數。如果 e-mail 地址不合法,則該函數返回一條錯誤消息
把 $email 變量設置為不合法的 e-mail 地址字符串
執行 "try" 代碼塊,由於 e-mail 地址不合法,因此拋出一個異常
"catch" 代碼塊捕獲異常,並顯示錯誤消息
多個異常
可以為一段腳本使用多個異常,來檢測多種情況。

可以使用多個 if..else 代碼塊,或一個 switch 代碼塊,或者嵌套多個異常。這些異常能夠使用不同的 exception 類,並返回不同的錯誤消息:

<?php
class customException extends Exception{public function errorMessage(){
//error
message$errorMsg = Error on line .$this->getLine(). in .$this->getFile().: <b>.$this->getMessage().</b> is not a valid E-Mail address;
return $errorMsg;
}
}
$email = "someone@example.com";try {
//check if 
if(filter_var($email, FILTER_VALIDATE_EMAIL) === FALSE)  { 
//throw exception if email is not valid  throw new
customException($email); 
}
//check for "example" in mail address
if(strpos($email, "example") !== FALSE)  {  throw new Exception("$email is an example e-mail");  } }catch (customException $e) { echo $e->errorMessage(); }catch(Exception $e) { echo $e->getMessage(); }?>
例子解釋:
上面的代碼測試瞭兩種條件,如何任何條件不成立,則拋出一個異常:

customException() 類是作為舊的 exception 類的一個擴展來創建的。這樣它就繼承瞭舊類的所有屬性和方法。
創建 errorMessage() 函數。如果 e-mail 地址不合法,則該函數返回一個錯誤消息。
執行 "try" 代碼塊,在第一個條件下,不會拋出異常。
由於 e-mail 含有字符串 "example",第二個條件會觸發異常。
"catch" 代碼塊會捕獲異常,並顯示恰當的錯誤消息
如果沒有捕獲 customException,緊緊捕獲瞭 base exception,則在那裡處理異常。
重新拋出異常
有時,當異常被拋出時,您也許希望以不同於標準的方式對它進行處理。可以在一個 "catch" 代碼塊中再次拋出異常。

腳本應該對用戶隱藏系統錯誤。對程序員來說,系統錯誤也許很重要,但是用戶對它們並不感興趣。為瞭讓用戶更容易使用,您可以再次拋出帶有對用戶比較友好的消息的異常:

<?phpclass customException extends Exception { public function errorMessage()  { 
//error message 
$errorMsg = $this->getMessage(). is not a valid E-Mail address.;  return $errorMsg;  } }$email = "someone@example.com";try { try  { 
//check for "example" in mail address 
if(strpos($email, "example") !== FALSE)   {  
//throw exception if email is not valid   throw new
Exception($email);   }  } catch(Exception $e)  { 
//re-throw exception  throw new
customException($email);  } }catch (customException $e) {
//display custom message
echo $e->errorMessage(); }?>
例子解釋:
上面的代碼檢測在郵件地址中是否含有字符串 "example"。如果有,則再次拋出異常:

customException() 類是作為舊的 exception 類的一個擴展來創建的。這樣它就繼承瞭舊類的所有屬性和方法。
創建 errorMessage() 函數。如果 e-mail 地址不合法,則該函數返回一個錯誤消息。
把 $email 變量設置為一個有效的郵件地址,但含有字符串 "

發佈留言